// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %                                                                   %
// %   IsoCSG Library - version 0.6                                    %
// %                                                                   %
// %   iso_bchars.inc - Variation with native CSG support and          %
// %                    automatic container calculation                %
// %                                                                   %
// %   developed March 2002 by ABX <abx@abx.art.pl>                    %
// %                                                                   %
// %   based on iso_chars include file                                 %
// %                                                                   %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %                                                                   %
// %   Feel free to use this file for your povray work, I encourage    %
// %   you to contact me if you have ideas for improvements.           %
// %                                                                   %
// %   This is an experimental version so syntax and used methods      %
// %   are subject to changes.                                         %
// %                                                                   %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#ifdef(iso_BChars_Inc_Temp)
// do nothing
#else
#declare iso_BChars_Inc_Temp=version;


#ifdef(View_POV_Include_Stack)
#   debug "including iso_bchars.inc\n"
#end

#ifndef(iso_Chars_Inc_Temp)
  #include "iso_chars.inc"
#end

#ifndef(iso_BCSG_Inc_Temp)
  #include "iso_bcsg.inc"
#end

#include "chars.inc"

#macro IC_Originall_Char ( _ICSG_Char )
  #local T=IC_Thickness();
  object{ _ICSG_Char scale T }
#end

#macro IC_BChar_A ()
  IC_Char_A () , IC_Originall_Char ( char_A )
#end

#macro IC_BChar_B ()
  IC_Char_B () , IC_Originall_Char ( char_B )
#end

#macro IC_BChar_C ()
  IC_Char_C () , IC_Originall_Char ( char_C )
#end

#macro IC_BChar_D ()
  IC_Char_D () , IC_Originall_Char ( char_D )
#end

#macro IC_BChar_E ()
  IC_Char_E () , IC_Originall_Char ( char_E )
#end

#macro IC_BChar_F ()
  IC_Char_F () , IC_Originall_Char ( char_F )
#end

#macro IC_BChar_G ()
  IC_Char_G () , IC_Originall_Char ( char_G )
#end

#macro IC_BChar_H ()
  IC_Char_H () , IC_Originall_Char ( char_H )
#end

#macro IC_BChar_I ()
  IC_Char_I () , IC_Originall_Char ( char_I )
#end

#macro IC_BChar_J ()
  IC_Char_J () , IC_Originall_Char ( char_J )
#end

#macro IC_BChar_K ()
  IC_Char_K () , IC_Originall_Char ( char_K )
#end

#macro IC_BChar_L ()
  IC_Char_L () , IC_Originall_Char ( char_L )
#end

#macro IC_BChar_M ()
  IC_Char_M () , IC_Originall_Char ( char_M )
#end

#macro IC_BChar_N ()
  IC_Char_N () , IC_Originall_Char ( char_N )
#end

#macro IC_BChar_O ()
  IC_Char_O () , IC_Originall_Char ( char_O )
#end

#macro IC_BChar_P ()
  IC_Char_P () , IC_Originall_Char ( char_P )
#end

#macro IC_BChar_Q ()
  IC_Char_Q () , IC_Originall_Char ( char_Q )
#end

#macro IC_BChar_R ()
  IC_Char_R () , IC_Originall_Char ( char_R )
#end

#macro IC_BChar_S ()
  IC_Char_S () , IC_Originall_Char ( char_S )
#end

#macro IC_BChar_T ()
  IC_Char_T () , IC_Originall_Char ( char_T )
#end

#macro IC_BChar_U ()
  IC_Char_U () , IC_Originall_Char ( char_U )
#end

#macro IC_BChar_V ()
  IC_Char_V () , IC_Originall_Char ( char_V )
#end

#macro IC_BChar_W ()
  IC_Char_W () , IC_Originall_Char ( char_W )
#end

#macro IC_BChar_X ()
  IC_Char_X () , IC_Originall_Char ( char_X )
#end

#macro IC_BChar_Y ()
  IC_Char_Y () , IC_Originall_Char ( char_Y )
#end

#macro IC_BChar_Z ()
  IC_Char_Z () , IC_Originall_Char ( char_Z )
#end

#macro IC_BChar_Dash ()
  IC_Char_Dash () , IC_Originall_Char ( char_Dash )
#end

#macro IC_BChar_Plus ()
  IC_Char_Plus () , IC_Originall_Char ( char_Plus )
#end

#macro IC_BChar_0 ()
  IC_Char_0 () , IC_Originall_Char ( char_0 )
#end

#macro IC_BChar_1 ()
  IC_Char_1 () , IC_Originall_Char ( char_1 )
#end

#macro IC_BChar_2 ()
  IC_Char_2 () , IC_Originall_Char ( char_2 )
#end

#macro IC_BChar_3 ()
  IC_Char_3 () , IC_Originall_Char ( char_3 )
#end

#macro IC_BChar_4 ()
  IC_Char_4 () , IC_Originall_Char ( char_4 )
#end

#macro IC_BChar_5 ()
  IC_Char_5 () , IC_Originall_Char ( char_5 )
#end

#macro IC_BChar_6 ()
  IC_Char_6 () , IC_Originall_Char ( char_6 )
#end

#macro IC_BChar_7 ()
  IC_Char_7 () , IC_Originall_Char ( char_7 )
#end

#macro IC_BChar_8 ()
  IC_Char_8 () , IC_Originall_Char ( char_8 )
#end

#macro IC_BChar_9 ()
  IC_Char_9 () , IC_Originall_Char ( char_9 )
#end

#macro IC_BChar_ExclPt()
  IC_Char_ExclPt () , IC_Originall_Char ( char_ExclPt )
#end

#macro IC_BChar_AtSign ()
  IC_Char_AtSign () , IC_Originall_Char ( char_AtSign )
#end

#macro IC_BChar_Num ()
  IC_Char_Num () , IC_Originall_Char ( char_Num )
#end

#macro IC_BChar_Dol ()
  IC_Char_Dol () , IC_Originall_Char ( char_Dol )
#end

#macro IC_BChar_Perc ()
  IC_Char_Perc () , IC_Originall_Char ( char_Perc )
#end

#macro IC_BChar_Hat ()
  IC_Char_Hat () , IC_Originall_Char ( char_Hat )
#end

#macro IC_BChar_Amps ()
  IC_Char_Amps () , IC_Originall_Char ( char_Amps )
#end

#macro IC_BChar_Astr ()
  IC_Char_Astr () , IC_Originall_Char ( char_Astr )
#end

#macro IC_BChar_LPar ()
  IC_Char_LPar () , IC_Originall_Char ( char_LPar )
#end

#macro IC_BChar_RPar ()
  IC_Char_RPar () , IC_Originall_Char ( char_RPar )
#end

#macro IC_BChar_LSqu ()
  IC_Char_LSqu () , IC_Originall_Char ( char_LSqu )
#end

#macro IC_BChar_RSqu ()
  IC_Char_RSqu () , IC_Originall_Char ( char_RSqu )
#end


#macro IC_BChar(_ICSG_Char)
  #switch(asc(_ICSG_Char))
    #case (  33 ) IC_BChar_ExclPt () #break /* ! */
    #case (  35 ) IC_BChar_Num    () #break /* # */
    #case (  36 ) IC_BChar_Dol    () #break /* $ */
    #case (  37 ) IC_BChar_Perc   () #break /* % */
    #case (  38 ) IC_BChar_Amps   () #break /* & */
    #case (  40 ) IC_BChar_LPar   () #break /* ( */
    #case (  41 ) IC_BChar_RPar   () #break /* ) */
    #case (  42 ) IC_BChar_Astr   () #break /* * */
    #case (  43 ) IC_BChar_Plus   () #break /* + */
    #case (  45 ) IC_BChar_Dash   () #break /* - */
    #case (  48 ) IC_BChar_0      () #break /* 0 */
    #case (  49 ) IC_BChar_1      () #break /* 1 */
    #case (  50 ) IC_BChar_2      () #break /* 2 */
    #case (  51 ) IC_BChar_3      () #break /* 3 */
    #case (  52 ) IC_BChar_4      () #break /* 4 */
    #case (  53 ) IC_BChar_5      () #break /* 5 */
    #case (  54 ) IC_BChar_6      () #break /* 6 */
    #case (  55 ) IC_BChar_7      () #break /* 7 */
    #case (  56 ) IC_BChar_8      () #break /* 8 */
    #case (  57 ) IC_BChar_9      () #break /* 9 */
    #case (  64 ) IC_BChar_AtSign () #break /* @ */
    #case (  65 ) IC_BChar_A      () #break /* A */
    #case (  66 ) IC_BChar_B      () #break /* B */
    #case (  67 ) IC_BChar_C      () #break /* C */
    #case (  68 ) IC_BChar_D      () #break /* D */
    #case (  69 ) IC_BChar_E      () #break /* E */
    #case (  70 ) IC_BChar_F      () #break /* F */
    #case (  71 ) IC_BChar_G      () #break /* G */
    #case (  72 ) IC_BChar_H      () #break /* H */
    #case (  73 ) IC_BChar_I      () #break /* I */
    #case (  74 ) IC_BChar_J      () #break /* J */
    #case (  75 ) IC_BChar_K      () #break /* K */
    #case (  76 ) IC_BChar_L      () #break /* L */
    #case (  77 ) IC_BChar_M      () #break /* M */
    #case (  78 ) IC_BChar_N      () #break /* N */
    #case (  79 ) IC_BChar_O      () #break /* O */
    #case (  80 ) IC_BChar_P      () #break /* P */
    #case (  81 ) IC_BChar_Q      () #break /* Q */
    #case (  82 ) IC_BChar_R      () #break /* R */
    #case (  83 ) IC_BChar_S      () #break /* S */
    #case (  84 ) IC_BChar_T      () #break /* T */
    #case (  85 ) IC_BChar_U      () #break /* U */
    #case (  86 ) IC_BChar_V      () #break /* V */
    #case (  87 ) IC_BChar_W      () #break /* W */
    #case (  88 ) IC_BChar_X      () #break /* X */
    #case (  89 ) IC_BChar_Y      () #break /* Y */
    #case (  90 ) IC_BChar_Z      () #break /* Z */
    #case (  91 ) IC_BChar_LSqu   () #break /* [ */
    #case (  93 ) IC_BChar_RSqu   () #break /* ] */
    #case (  94 ) IC_BChar_Hat    () #break /* ^ */
    #case (  97 ) IC_BChar_A      () #break /* a */
    #case (  98 ) IC_BChar_B      () #break /* b */
    #case (  99 ) IC_BChar_C      () #break /* c */
    #case ( 100 ) IC_BChar_D      () #break /* d */
    #case ( 101 ) IC_BChar_E      () #break /* e */
    #case ( 102 ) IC_BChar_F      () #break /* f */
    #case ( 103 ) IC_BChar_G      () #break /* g */
    #case ( 104 ) IC_BChar_H      () #break /* h */
    #case ( 105 ) IC_BChar_I      () #break /* i */
    #case ( 106 ) IC_BChar_J      () #break /* j */
    #case ( 107 ) IC_BChar_K      () #break /* k */
    #case ( 108 ) IC_BChar_L      () #break /* l */
    #case ( 109 ) IC_BChar_M      () #break /* m */
    #case ( 110 ) IC_BChar_N      () #break /* n */
    #case ( 111 ) IC_BChar_O      () #break /* o */
    #case ( 112 ) IC_BChar_P      () #break /* p */
    #case ( 113 ) IC_BChar_Q      () #break /* q */
    #case ( 114 ) IC_BChar_R      () #break /* r */
    #case ( 115 ) IC_BChar_S      () #break /* s */
    #case ( 116 ) IC_BChar_T      () #break /* t */
    #case ( 117 ) IC_BChar_U      () #break /* u */
    #case ( 118 ) IC_BChar_V      () #break /* v */
    #case ( 119 ) IC_BChar_W      () #break /* w */
    #case ( 120 ) IC_BChar_X      () #break /* x */
    #case ( 121 ) IC_BChar_Y      () #break /* y */
    #case ( 122 ) IC_BChar_Z      () #break /* z */
    #else
      #local T=IC_Thickness();
      IC_BMerge4 (
        IC_BBox ( <-2,0,0> , < 2,1,T> ),
        IC_BBox ( <-2,4,0> , < 2,5,T> ),
        IC_BBox ( <-2,0,0> , <-1,5,T> ),
        IC_BBox ( < 1,0,0> , < 2,5,T> )
      )
  #end
#end

#macro IC_BText ( _ICSG_String , IC_Text_Thickness , _ICSG_Offset )

  #local Start=2*x;
  #local Offset=5*x+_ICSG_Offset;

  #local C=0;
  #local Chars=0;
  #while ( C < strlen( _ICSG_String ) )
    #local C=C+1;
    #if ( asc( substr( _ICSG_String , C , 1 ) ) !=32 )
      #local Chars=Chars+1;
      #local Pos=C;
    #end
  #end

  #switch (Chars)
    #case (0)
      #error "iso_bchars.inc: Empty string in IC_Text macro"
    #break
    #case (1)
      IC_BTranslate ( IC_BChar ( substr( _ICSG_String , Pos , 1 ) ) , (Pos-1)*Offset + Start )
    #break
    #else
      #local Array = array[Chars];
      #local C=0;
      #local Chars=0;
      #local Common_Container = union{
        #while ( C < strlen( _ICSG_String ) )
          #local C=C+1;
          #if ( asc( substr( _ICSG_String , C , 1 ) ) !=32 )
            IC_Object( IC_BTranslate ( IC_BChar ( substr( _ICSG_String , C , 1 ) ) , (C-1)*Offset + Start ) )
            #local Array[ Chars ] = IC_Translate ( IC_Char ( substr( _ICSG_String , C , 1 ) ) , (C-1)*Offset + Start );
            #local Chars=Chars+1;
          #end
        #end
      };
      IC_BMerge_Array( Array , Common_Container )
    #end

#end

// End of ISO_CHARS.INC
#version iso_Chars_Inc_Temp;
#end
