// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test05.pov
// Vers: 3.5
// Desc: demo for 'B' version iso_csg demo  
//       generating either IsoCSG or native CSG version 
//       depending on the 'Iso_Object' switch
// Date: Mar. 2002
// Auth: Christoph Hormann
//

#version 3.5;

global_settings {
  assumed_gamma 1.0 
}   

background { color <0.750,0.500,0.300> } 
    
camera {
  location <0.2,0.2,-1>  
  look_at  <0,0,0>
  right (4/3)*x                
} 

light_source {     
  <1000, 2500, -5000> 
  color rgb 1.2
}     

#declare Iso_Object=true;

#include "iso_bcsg.inc"

// ----- POV logo ------   

#declare fn_XX=
IC_Extents(  
  IC_BTransform(       
    IC_BMerge3(  
      IC_BSphere(2*y, 1), 
      IC_BDifference2( 
        IC_BCone(2*y, 1, -4*y, 0),       
        IC_BScaleC(IC_BSphere(2*y, 1.4), <1,1,2>)  
      ),
      IC_BTransform(
        IC_BDifference2(  
          IC_BScaleC(IC_BSphere(0, 1), <2.6, 2.2, 1>),            
          IC_BTranslate(IC_BScaleC(IC_BSphere(0, 1), <2.3, 1.8, 2>), <-0.35, 0, 0>) 
        ),  
        transform { rotate z*30 translate 2*y }
      )
    ),   
    transform {
      rotate <0, 0, -25>
      translate <-0.5,-0.35,0>
    }
  )
) 

#declare Obj_XX=
IC_Object(  
  IC_BTransform(       
    IC_BMerge3(  
      IC_BSphere(2*y, 1), 
      IC_BDifference2( 
        IC_BCone(2*y, 1, -4*y, 0),       
        IC_BScaleC(IC_BSphere(2*y, 1.4), <1,1,2>)  
      ),
      IC_BTransform(
        IC_BDifference2(  
          IC_BScaleC(IC_BSphere(0, 1), <2.6, 2.2, 1>),            
          IC_BTranslate(IC_BScaleC(IC_BSphere(0, 1), <2.3, 1.8, 2>), <-0.35, 0, 0>) 
        ),  
        transform { rotate z*30 translate 2*y }
      )
    ),   
    transform {
      rotate <0, 0, -25>
      translate <-0.5,-0.35,0>
    }
  )
)


#if (Iso_Object)
  isosurface {                                                                                     
    function { fn_XX(x, y, z) }  
    max_gradient 1.6 
    contained_by { box { IC_Min, IC_Max } }
    pigment { rgb <0, 0.2, 1.1> } 
    finish { specular 0.3 } 
    scale 0.1
  } 
#else
  object {                                                                                     
    Obj_XX
    pigment { rgb <0, 0.2, 1.1> } 
    finish { specular 0.3 } 
    scale 0.1
  } 
#end 
 